;This program draws a box onto the screen of a ti83plus calculator
;The box can then be moved by pressing the arrow keys
;Everything that the program does is done by interacting directly
;with the hardware
	
	.org	9D93h
	.db	0BBh, 6Dh
Start:
	ld	a, (XShft)
	ld	h, a
	ld	a, (YPos)	;get X and Y and then draw a box onto the screen
	ld	b, a
	ld	a, (XPos)
	call	DRAW		;draw will happen on every iteration of the loop (inefficient)
ReStart:
	call	GARROW
	cp	0 		
	jp	z, chkclr	;check if an arrow key was pressed
N0:				;not 0 (this label is not used it is just here to help make things understandable)
	cp	1		;if an arrow key was pressed figure out which one it was (1=down)
	jp	nz, N1		;if down was not pressed then check the next key
	ld	a, (YPos)	;if down was pressed then make sure the box won't move off__ 
	cp	0B6h		;__the screen and then ERASE the current box and increment the YPos
	jp	z, cont
	ld	b, a
	ld	a, (XPos)
	ld	c, a
	call	ERASE		;Erase before redraw
	ld	hl, YPos
	inc	(hl)
	jp	cont

N1:				;NOT1
	cp	2
	jp	nz, N2		;check if left was pressed
	ld	a, (XPos)
	cp	20h
	jp	z, chkShft	;if on far left check if box can still be shifted left
shfLeft:
	ld	a, (YPos)
	ld	b, a
	ld	a, (XPos)
	ld	c, a
	call	ERASE
	ld	hl, XShft
	ld	a, (hl)
	cp	0h		;check if box has been shifted to previous position
	jp	z, decX		;and decrement XPos if it has
	dec	(hl)		;else decrement XShft
	jp	cont
decX:
	ld	(hl), 7h	;set XShft to max (7)
	ld	hl, XPos
	dec	(hl)		;go to previous XPos
	jp	cont
chkShft:
	ld	hl, XShft
	ld	a, (hl)
	cp	0h		;check if box has been shifted to 0 already
	jp	nz, shfLeft	;shift left if it is not zero
	jp	cont		;continue if it is already zero
N2:	
	cp	3
	jp	nz, N3		;check if up was pressed
	ld	a, (YPos)
	cp	80h
	jp	z, cont
	ld	b, a
	ld	a, (XPos)
	ld	c, a
	call	ERASE
	ld	hl, YPos
	dec	(hl)
	jp	cont
N3:
	cp	4
	jp	nz, cont	;check if right pressed
	ld	a, (XPos)
	cp	2bh
	jp	z, cont	
	ld	a, (YPos)
	ld	b, a
	ld	a, (XPos)
	ld	c, a
	call	ERASE

	ld	hl, XShft
	ld	a, (hl)
	cp	7h		;check if box has been shifted to next position
	jp	z, incX		;and inc XPos if it has
	inc	(hl)		;else increment XShft
	jp	cont
incX:
	ld	(hl), 0		;set XShft to 0
	ld	hl, XPos
	inc	(hl)		;go to next XPos
cont:
	call	GCLR		;check if clr was pressed and exit if it was
	cp	1
	jp	nz, Start
	jp	end
chkclr:
	call	GCLR
	cp	1
	jp	nz, ReStart
end:
	ret

;X and Y of box on screen
XPos:
	.db	22h
YPos:
	.db	80h
XShft:				;solves problem of shifting too far
	.db	0h		;when left or right arrow is pressed

#include "direct.asm"
